/**
  ******************************************************************************
  * @file    Watchdog_Driver.h
  * @author  Hugo Vargas Llanas, _KEMET Ltd.
  * @date    21-April-2015
  * @brief   This file contains all the functions involving the watchdog Timer
  ******************************************************************************
    */

#ifndef Watchdog_Driver
#define Watchdog_Driver

/* Includes ------------------------------------------------------------------*/
#include "stm32f30x_iwdg.h"

/* Defines -------------------------------------------------------------------*/
#define     WATCHDOG_LONG_TIMEOUT_DEFAULT    0xC35     // 20 Seconds
#define     WATCHDOG_SHORT_TIMEOUT_DEFAULT   0x1D5         // 3 Seconds
#define     WATCHDOG_TIMEOUT_SETTING_DEFAULT Short_Timeout
#define     WATCHDOG_ENABLE_DEFAULT          0
typedef enum
{
    Short_Timeout, /*!<  */
    Long_Timeout,  /*!<  */
} Timeout_Length_Type;
typedef struct
{
    uint8_t                             Enabled;
    uint16_t                            Short_Timeout;
    uint16_t                            Long_Timeout;
    Timeout_Length_Type     Timeout_Setting_Default;
} Watchdog_Config_Type;

/* Functional Control Functions **************************/
void Watchdog_Init (Watchdog_Config_Type * External_Config);
void Reload_Counter (void);
void Timeout_Set(Timeout_Length_Type Timeout_Length_Types);

#endif
/* ********** Copyright (c) 2018 _KEMET, Ltd. **********END OF FILE************/

